/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package so.winwebdocentes.servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Enumeration;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.json.JSONObject;
import so.winwebdocentes.services.AsistenciaService;
import so.winwebdocentes.services.DatabaseService;
import so.winwebdocentes.services.DocenteService;
import so.winwebdocentes.services.ReporteAsistProfesoresPorMesServices;

/**
 *
 * @author Felipe Escala
 */
public class AsistenciaServlet extends HttpServlet {

	@Override
	protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		String param = request.getParameter("accion");
		if (null != param) {
			switch (param) {
				case "listarDocentesSelect2":
					listarDocentesSelect2(request, response);
					break;
				case "listarAniosDB":
					listarAniosDB(request, response);
					break;
				case "listarMesesActivos":
					listarMesesActivos(request, response);
					break;
				case "listarRazonSocial":
					listarRazonSocial(request, response);
					break;
				case "listarAsistencias":
					listarAsistencias(request, response);
					break;
				case "listarSueldos":
					listarSueldos(request, response);
					break;
				case "listarMontosPorPago":
					listarMontosPorPago(request, response);
					break;
				case "listarResumenRS":
					listarResumenRS(request, response);
					break;
				case "listarResumenPagos":
					listarResumenPagos(request, response);
					break;
				case "listarDetalleDescuento":
					listarDetalleDescuento(request, response);
					break;
				case "listarDescuentosMensual":
					listarDescuentosMensual(request, response);
					break;
				default:
					break;
			}
		}
	}

	private void listarDocentesSelect2(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		DocenteService srv = new DocenteService();
		JSONObject rs = srv.listarDocentesSelect2(new JSONObject()
			.put("search", request.getParameter("search"))
			.put("page", request.getParameter("page"))
			.put("year", request.getParameter("year"))
		);
		out.println(rs);
	}

	private void listarAniosDB(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		JSONObject json = new JSONObject();
		DatabaseService srv = new DatabaseService();
		JSONObject rs = srv.listarAniosDB(json);
		out.println(rs);
	}

	private void listarMesesActivos(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		String jsonString = request.getParameter("json");
		JSONObject json = new JSONObject(jsonString);
		DatabaseService srv = new DatabaseService();
		JSONObject rs = srv.listarMesesActivos(json);
		out.println(rs);
	}

	private void listarRazonSocial(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		String jsonString = request.getParameter("json");
		JSONObject json = new JSONObject(jsonString);
		AsistenciaService srv = new AsistenciaService();
		JSONObject rs = srv.listarRazonSocial(json);
		out.println(rs);
	}

	private void listarAsistencias(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		AsistenciaService srv = new AsistenciaService();
		String jsonString = request.getParameter("json");
		JSONObject json = new JSONObject(jsonString);
		JSONObject rs = srv.listarAsistencias(json);
		out.println(rs);
	}

	private void listarSueldos(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		DocenteService srv = new DocenteService();
		String jsonString = request.getParameter("json");
		JSONObject json = new JSONObject(jsonString);
		JSONObject rs = srv.listarSueldos(json);
		out.println(rs);
	}

	private void listarMontosPorPago(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		AsistenciaService srv = new AsistenciaService();
		String jsonString = request.getParameter("json");
		JSONObject json = new JSONObject(jsonString);
		JSONObject rs = srv.listarMontosPorPago(json);
		out.println(rs);
	}

	private void listarResumenRS(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		AsistenciaService srv = new AsistenciaService();
		String jsonString = request.getParameter("json");
		JSONObject json = new JSONObject(jsonString);
		JSONObject rs = srv.listarResumenRS(json);
		out.println(rs);
	}

	private void listarResumenPagos(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		AsistenciaService srv = new AsistenciaService();
		String jsonString = request.getParameter("json");
		JSONObject json = new JSONObject(jsonString);
		JSONObject rs = srv.listarResumenPagos(json);
		out.println(rs);
	}

	private void listarDetalleDescuento(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		AsistenciaService srv = new AsistenciaService();
		String jsonString = request.getParameter("json");
		JSONObject json = new JSONObject(jsonString);
		JSONObject rs = srv.listarDetalleDescuento(json);
		out.println(rs);
	}

	private void listarDescuentosMensual(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter out = response.getWriter();
		ReporteAsistProfesoresPorMesServices srv = new ReporteAsistProfesoresPorMesServices();
		String jsonString = request.getParameter("json");
		JSONObject json = new JSONObject(jsonString);
		JSONObject rs = srv.listarDescuentosMensual(json);
		out.println(rs);
	}

}
