/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package so.winwebdocentes.sqlserverDAO;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.Calendar;
import org.json.JSONArray;
import org.json.JSONObject;
import so.winwebdocentes.DAO.DocenteDAO;
import so.winwebdocentes.utilities.ResponseHelper;

/**
 *
 * @author Felipe Escala
 */
public class DocenteSqlServerDAO implements DocenteDAO {

	@Override
	public JSONObject listarDocentesSelect2(JSONObject datos) throws Exception {
		String year = datos.has("year") ? datos.getString("year") : String.valueOf(Calendar.getInstance().get(Calendar.YEAR));
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = SqlServerDAOFactory.obtenerConexion("sacoolive" + year, year);
			sql = " select  top 10 "
				+ " p.codprofesor, p.apellido, p.nombre, "
				+ " p.dni, p.tiposueldo, p.TIPOPLLA, p.horario "
				+ " from profesor as p "
				+ " where p.dni like ? "
				+ " or p.apellido like ? "
				+ " and p.codprofesor not in "
				+ " ( "
				+ "	select top " + (datos.getInt("page") - 1) * 10 + " "
				+ "	p.codprofesor from profesor as p "
				+ "	where p.dni like ? or p.apellido like ? "
				+ " ) ";
			pst = con.prepareStatement(sql);
			int c = 1;
			pst.setString(c++, "%" + datos.getString("search") + "%");
			pst.setString(c++, "%" + datos.getString("search") + "%");
			pst.setString(c++, "%" + datos.getString("search") + "%");
			pst.setString(c++, "%" + datos.getString("search") + "%");
			rSet = pst.executeQuery();
			while (rSet.next()) {
				c = 1;
				JSONObject obj = new JSONObject();
				obj.put("id", rSet.getString(c++));
				obj.put("apellidoProfesor", rSet.getString(c++));
				obj.put("nombreProfesor", rSet.getString(c++));
				obj.put("dniProfesor", rSet.getString(c++));
				obj.put("tipoSueldo", rSet.getString(c++));
				obj.put("tipoPlanilla", rSet.getString(c++));
				obj.put("contratoProfesor", rSet.getString(c++));
				lista.put(obj);
			}
			sql = " select "
				+ " count(*) "
				+ " from profesor as p "
				+ " where p.dni like ? "
				+ " or p.apellido like ? ";
			pst = con.prepareStatement(sql);
			c = 1;
			pst.setString(c++, "%" + datos.getString("search") + "%");
			pst.setString(c++, "%" + datos.getString("search") + "%");
			rSet = pst.executeQuery();
			rSet.next();
			rs = rSet.getInt(1);
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {

					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		data.put("total_count", rs);
		data.put("incomplete_results", true);
		data.put("items", lista);
		return data;
	}

	@Override
	public JSONObject listarDatosDocente(JSONObject datos) throws Exception {
		String year = datos.has("year") ? datos.getString("year") : String.valueOf(Calendar.getInstance().get(Calendar.YEAR));
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = SqlServerDAOFactory.obtenerConexion("sacoolive" + year, year);
			sql = "  ";
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		jreturn = new JSONObject(response);
		return jreturn;
	}

	@Override
	public JSONObject listarSueldos(JSONObject datos) throws Exception {
		String year = datos.has("year") ? datos.getString("year") : String.valueOf(Calendar.getInstance().get(Calendar.YEAR));
		JSONObject jreturn;
		JSONArray lista = new JSONArray();
		JSONObject data = new JSONObject();
		Connection con = null;
		PreparedStatement pst = null;
		ResultSet rSet = null;
		int rs = 0;
		String sql = "";
		ResponseHelper response = new ResponseHelper();
		try {
			con = SqlServerDAOFactory.obtenerConexion("sacoolive" + year, year);
			sql = " select COUNT(*) "
				+ "  from information_schema.routines  "
				+ " where routine_type = 'PROCEDURE' "
				+ "AND specific_name = 'listarSueldos_V2' "
				+ "AND specific_schema = 'dbo' ";
			pst = con.prepareStatement(sql);
			rSet = pst.executeQuery();
			if (rSet.next()) {
				rs = rSet.getInt(1);
			}
			if (rs != 1) {
				sql = " CREATE PROCEDURE [dbo].[listarSueldos_V2]   "
					+ "    @codigoProfesor nvarchar(25)   "
					+ "AS    "
					+ "	SELECT 'SUELDO', ISNULL(CAST(sueldo AS NUMERIC(8,2)), '.00') FROM profesor  "
					+ "	WHERE codprofesor = @codigoProfesor "
					+ "	UNION ALL "
					+ "	SELECT 'PAGO A', CAST(pagoa AS NUMERIC(8,2)) FROM profesor  "
					+ "	WHERE codprofesor = @codigoProfesor "
					+ "	UNION ALL "
					+ "	SELECT 'PAGO B', CAST(pagob AS NUMERIC(8,2)) FROM profesor  "
					+ "	WHERE codprofesor = @codigoProfesor "
					+ "	UNION ALL "
					+ "	SELECT 'PAGO C', CAST(pagoc AS NUMERIC(8,2)) FROM profesor  "
					+ "	WHERE codprofesor = @codigoProfesor "
					+ "	UNION ALL "
					+ "	SELECT 'PAGO D', CAST(pagod AS NUMERIC(8,2)) FROM profesor  "
					+ "	WHERE codprofesor = @codigoProfesor "
					+ "	UNION ALL "
					+ "	SELECT 'PAGO E', CAST(pagoe AS NUMERIC(8,2)) FROM profesor  "
					+ "	WHERE codprofesor = @codigoProfesor "
					+ "	UNION ALL "
					+ "	SELECT 'PAGO F', CAST(pagof AS NUMERIC(8,2)) FROM profesor  "
					+ "	WHERE codprofesor = @codigoProfesor "
					+ "	UNION ALL "
					+ "	SELECT 'PAGO G', CAST(pagog AS NUMERIC(8,2)) FROM profesor  "
					+ "	WHERE codprofesor = @codigoProfesor "
					+ "	UNION ALL "
					+ "	SELECT 'PAGO H', CAST(pagoh AS NUMERIC(8,2)) FROM profesor  "
					+ "	WHERE codprofesor = @codigoProfesor  ";
				pst = con.prepareStatement(sql);
				pst.executeUpdate();
			}
			sql = " {CALL dbo.listarSueldos_V2 (?)} ";
			pst = con.prepareStatement(sql);
			pst.setString(1, datos.getString("codigoDocente"));
			rSet = pst.executeQuery();
			while (rSet.next()) {
				JSONObject obj = new JSONObject();
				obj.put("nombrePago", rSet.getString(1));
				obj.put("montoPago", rSet.getString(2));
				lista.put(obj);
			}
			response.setStatus(lista.length() >= 1);
			response.setResults(lista);
		} catch (Exception e) {
			e.printStackTrace();
			response.setStatus(false);
			response.setMessage("Error --->" + e.getMessage());
		} finally {
			try {
				if (rSet != null) {
					rSet.close();
				}
				if (pst != null) {
					pst.close();
				}
				if (con != null) {
					con.close();
				}
			} catch (Exception e) {
				e.printStackTrace();
				response.setStatus(false);
				response.setMessage("Error --->" + e.getMessage());
			}
		}
		jreturn = new JSONObject(response);
		return jreturn;
	}
}
