package so.winwebdocentes.sqlserverDAO;

import java.sql.*;
import java.util.ArrayList;
import so.winwebdocentes.beans.ReporteAsistProfesoresPorAnio;
import so.winwebdocentes.DAO.ReporteAsistProfesoresPorAnioDAO;
import so.winwebdocentes.utilities.GeneralMethods;

public class SQLReporteAsistProfesoresPorAnioDAO implements ReporteAsistProfesoresPorAnioDAO {

	@Override
	public ArrayList<ReporteAsistProfesoresPorAnio> listrarReporteAsistProfesoresPorAnio(String dbanio) throws Exception {
		ArrayList<ReporteAsistProfesoresPorAnio> listrarReporteAsistProfesoresPorAnio = new ArrayList<>();
		String base = "sacoolive" + dbanio;
		Connection cnx = SqlServerDAOFactory.obtenerConexion(base, dbanio);
		Statement st = cnx.createStatement();
		GeneralMethods.validarVistaExportar(st);
		String sql = "select * from vista_exportar_todos_profesores_V2 order by nro_mes, fecha_asistencia, apellidos ";
		ResultSet rs = st.executeQuery(sql);
		while (rs.next()) {
			ReporteAsistProfesoresPorAnio rp = new ReporteAsistProfesoresPorAnio();
			rp.setApellidos(rs.getString("apellidos"));
			rp.setNombres(rs.getString("nombres"));
			rp.setDni(rs.getString("dni"));
			rp.setAbreviatura_asociacion(rs.getString("abreviatura_asociacion"));
			rp.setNombre_asociacion(rs.getString("nombre_asociacion"));
			rp.setNombre_local(rs.getString("nombre_local"));
			rp.setAcumulado_cantidad_minutos(rs.getString("acumulado_cantidad_minutos"));
			rp.setAcumulado_horas(rs.getString("acumulado_horas"));
			rp.setAcumulado_minutos(rs.getString("acumulado_minutos"));
			rp.setCodsec(rs.getString("codsec"));
			rp.setMonto_asistencia(rs.getString("monto_asistencia"));
			rp.setFecha_asistencia(rs.getString("fecha_asistencia"));
			rp.setNombre_mes(rs.getString("nombre_mes"));
			rp.setNro_mes(rs.getString("nro_mes"));
			listrarReporteAsistProfesoresPorAnio.add(rp);
		}
		return listrarReporteAsistProfesoresPorAnio;
	}

	@Override
	public ArrayList<ReporteAsistProfesoresPorAnio> listrar_netosReporteAsistProfesoresPorAnio(String dbanio) throws Exception {
		ArrayList<ReporteAsistProfesoresPorAnio> listrarReporteAsistProfesoresPorAnio = new ArrayList<>();
		String base = "sacoolive" + dbanio;
		Connection cnx = SqlServerDAOFactory.obtenerConexion(base, dbanio);
		Statement st = cnx.createStatement();
		GeneralMethods.validarVistaExportar(st);
		String sql
			= " select "
			+ " cast(sum(v.acumulado_cantidad_minutos) as integer) as neto_acumulado_cantidad_minutos,"
			+ " sum(v.acumulado_horas) as neto_acumulado_horas,"
			+ " sum(v.acumulado_minutos) as neto_acumulado_minutos,"
			+ " sum(v.monto_asistencia) as neto_monto_asistencia"
			+ " from vista_exportar_todos_profesores_V2 v";
		ResultSet rs = st.executeQuery(sql);
		while (rs.next()) {
			ReporteAsistProfesoresPorAnio rp = new ReporteAsistProfesoresPorAnio();
			rp.setNeto_acumulado_cantidad_minutos(rs.getString("neto_acumulado_cantidad_minutos"));
			rp.setNeto_acumulado_horas(rs.getString("neto_acumulado_horas"));
			rp.setNeto_acumulado_minutos(rs.getString("neto_acumulado_minutos"));
			rp.setNeto_monto_asistencia(rs.getString("neto_monto_asistencia"));
			listrarReporteAsistProfesoresPorAnio.add(rp);
		}
		return listrarReporteAsistProfesoresPorAnio;
	}

}
