   /* global CONSTANTES */

   const $form = $('.form');

   const helpers = {
      spinnerOff() {
         $form.addClass('form-done');
         setTimeout(() => {
            $form
                    .removeClass('form-submitted')
                    .removeClass('form-done');
         }, 300);
      },
      spinnerOn() {
         $form.addClass('form-submitted');
      }
   }

   const httpRequest = {
      login(json) {
         return new Promise((resolve, reject) => {
            $.ajax({
               type: 'POST',
               url: '../vistas/login',
               dataType: "json",
               headers: {
                  "Accept": 'application/json'
               },
               data: {
                  body: JSON.stringify(json)
               },
               beforeSend: function (xhr) {
                  helpers.spinnerOn()
               },
               success: function (data, textStatus, jqXHR) {

                  console.log(data);
                  resolve(data)
               }, error: function (jqXHR, textStatus, errorThrown) {
                  helpers.spinnerOff()
                  reject({
                     status: jqXHR.status,
                     throw: errorThrown || {},
                     jqXHR: jqXHR,
                     request: json
                  })
               }
            })
         })
      }
   }

   const DOMEvents = {
      init() {
         this.signIn()
         this.pressEnter()
      },
      signIn() {
         document.querySelector('#logIn').addEventListener('click', (e) => {
            validarBusq = $("#formLogin").validate({
               rules: {
                  user:
                          {required: true, maxlength: 50},
                  password:
                          {required: true, maxlength: 50}
               },
               messages: {
                  user:
                          {required: "&times; Ingrese su Usuario", maxlength: "&times; Máximo 50 letras"},
                  password:
                          {required: "&times; Ingrese su Contraseña", maxlength: "&times; Máximo 50 letras"}
               },
               errorPlacement: function (error, element) {}
            });
            if (validarBusq.form()) {
               let params = {
                  usuario: document.querySelector('#user').value.trim(),
                  pass: document.querySelector('#password').value,
                  codigoProyecto: CONSTANTES.CODIGO_PROYECTO_MATRICULA
               }
               httpRequest.login(params)
                       .then(data => {
                          if (data.status) {
                             window.location.href = "../vistas/main.jsp";
                          } else {
                             helpers.spinnerOff()
                             $('#password').val("");
                             $('#password').focus();
                             $('#msnErrorLogin').fadeOut();
                             $('#msnErrorLogin').fadeIn();
                          }
                       })
                       .catch(err => console.log(err))
            }
         })
      },
      pressEnter() {
         $(window).bind('keypress', function (e) {
            if (e.charCode === 13 || e.keyCode === 13) {
               $('#logIn').click()
            }
         })
      }
   }
   DOMEvents.init()

   